// A Bison parser, made by GNU Bison 3.7.2.

// Skeleton implementation for Bison LALR(1) parsers in C++

// Copyright (C) 2002-2015, 2018-2020 Free Software Foundation, Inc.

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

// As a special exception, you may create a larger work that contains
// part or all of the Bison parser skeleton and distribute that work
// under terms of your choice, so long as that work isn't itself a
// parser generator using the skeleton or a modified version thereof
// as a parser skeleton.  Alternatively, if you modify or redistribute
// the parser skeleton itself, you may (at your option) remove this
// special exception, which will cause the skeleton and the resulting
// Bison output files to be licensed under the GNU General Public
// License without this special exception.

// This special exception was added by the Free Software Foundation in
// version 2.2 of Bison.

// DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
// especially those whose name start with YY_ or yy_.  They are
// private implementation details that can be changed or removed.



// First part of user prologue.
#line 44 "parser.yy"

    #include "node.h"
    #include "parser.h"
    using std::unique_ptr;
    using std::vector;
    using std::string;
    using std::move;

#line 50 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"


#include "parser.yy.hh"


// Unqualified %code blocks.
#line 38 "parser.yy"

    static int yylex(ebpf::cc::BisonParser::semantic_type *yylval,
                     ebpf::cc::BisonParser::location_type *yylloc,
                     ebpf::cc::Lexer &lexer);

#line 63 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"


#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> // FIXME: INFRINGES ON USER NAME SPACE.
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif


// Whether we are compiled with exception support.
#ifndef YY_EXCEPTIONS
# if defined __GNUC__ && !defined __EXCEPTIONS
#  define YY_EXCEPTIONS 0
# else
#  define YY_EXCEPTIONS 1
# endif
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K].location)
/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

# ifndef YYLLOC_DEFAULT
#  define YYLLOC_DEFAULT(Current, Rhs, N)                               \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).begin  = YYRHSLOC (Rhs, 1).begin;                   \
          (Current).end    = YYRHSLOC (Rhs, N).end;                     \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).begin = (Current).end = YYRHSLOC (Rhs, 0).end;      \
        }                                                               \
    while (false)
# endif


// Enable debugging if requested.
#if YYDEBUG

// A pseudo ostream that takes yydebug_ into account.
# define YYCDEBUG if (yydebug_) (*yycdebug_)

# define YY_SYMBOL_PRINT(Title, Symbol)         \
  do {                                          \
    if (yydebug_)                               \
    {                                           \
      *yycdebug_ << Title << ' ';               \
      yy_print_ (*yycdebug_, Symbol);           \
      *yycdebug_ << '\n';                       \
    }                                           \
  } while (false)

# define YY_REDUCE_PRINT(Rule)          \
  do {                                  \
    if (yydebug_)                       \
      yy_reduce_print_ (Rule);          \
  } while (false)

# define YY_STACK_PRINT()               \
  do {                                  \
    if (yydebug_)                       \
      yy_stack_print_ ();                \
  } while (false)

#else // !YYDEBUG

# define YYCDEBUG if (false) std::cerr
# define YY_SYMBOL_PRINT(Title, Symbol)  YYUSE (Symbol)
# define YY_REDUCE_PRINT(Rule)           static_cast<void> (0)
# define YY_STACK_PRINT()                static_cast<void> (0)

#endif // !YYDEBUG

#define yyerrok         (yyerrstatus_ = 0)
#define yyclearin       (yyla.clear ())

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYRECOVERING()  (!!yyerrstatus_)

#line 19 "parser.yy"
namespace ebpf { namespace cc {
#line 156 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"

  /// Build a parser object.
  BisonParser::BisonParser (ebpf::cc::Lexer &lexer_yyarg, ebpf::cc::Parser &parser_yyarg)
#if YYDEBUG
    : yydebug_ (false),
      yycdebug_ (&std::cerr),
#else
    :
#endif
      lexer (lexer_yyarg),
      parser (parser_yyarg)
  {}

  BisonParser::~BisonParser ()
  {}

  BisonParser::syntax_error::~syntax_error () YY_NOEXCEPT YY_NOTHROW
  {}

  /*---------------.
  | symbol kinds.  |
  `---------------*/

  // basic_symbol.
  template <typename Base>
  BisonParser::basic_symbol<Base>::basic_symbol (const basic_symbol& that)
    : Base (that)
    , value (that.value)
    , location (that.location)
  {}


  /// Constructor for valueless symbols.
  template <typename Base>
  BisonParser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, YY_MOVE_REF (location_type) l)
    : Base (t)
    , value ()
    , location (l)
  {}

  template <typename Base>
  BisonParser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, YY_RVREF (semantic_type) v, YY_RVREF (location_type) l)
    : Base (t)
    , value (YY_MOVE (v))
    , location (YY_MOVE (l))
  {}

  template <typename Base>
  BisonParser::symbol_kind_type
  BisonParser::basic_symbol<Base>::type_get () const YY_NOEXCEPT
  {
    return this->kind ();
  }

  template <typename Base>
  bool
  BisonParser::basic_symbol<Base>::empty () const YY_NOEXCEPT
  {
    return this->kind () == symbol_kind::S_YYEMPTY;
  }

  template <typename Base>
  void
  BisonParser::basic_symbol<Base>::move (basic_symbol& s)
  {
    super_type::move (s);
    value = YY_MOVE (s.value);
    location = YY_MOVE (s.location);
  }

  // by_kind.
  BisonParser::by_kind::by_kind ()
    : kind_ (symbol_kind::S_YYEMPTY)
  {}

#if 201103L <= YY_CPLUSPLUS
  BisonParser::by_kind::by_kind (by_kind&& that)
    : kind_ (that.kind_)
  {
    that.clear ();
  }
#endif

  BisonParser::by_kind::by_kind (const by_kind& that)
    : kind_ (that.kind_)
  {}

  BisonParser::by_kind::by_kind (token_kind_type t)
    : kind_ (yytranslate_ (t))
  {}

  void
  BisonParser::by_kind::clear ()
  {
    kind_ = symbol_kind::S_YYEMPTY;
  }

  void
  BisonParser::by_kind::move (by_kind& that)
  {
    kind_ = that.kind_;
    that.clear ();
  }

  BisonParser::symbol_kind_type
  BisonParser::by_kind::kind () const YY_NOEXCEPT
  {
    return kind_;
  }

  BisonParser::symbol_kind_type
  BisonParser::by_kind::type_get () const YY_NOEXCEPT
  {
    return this->kind ();
  }


  // by_state.
  BisonParser::by_state::by_state () YY_NOEXCEPT
    : state (empty_state)
  {}

  BisonParser::by_state::by_state (const by_state& that) YY_NOEXCEPT
    : state (that.state)
  {}

  void
  BisonParser::by_state::clear () YY_NOEXCEPT
  {
    state = empty_state;
  }

  void
  BisonParser::by_state::move (by_state& that)
  {
    state = that.state;
    that.clear ();
  }

  BisonParser::by_state::by_state (state_type s) YY_NOEXCEPT
    : state (s)
  {}

  BisonParser::symbol_kind_type
  BisonParser::by_state::kind () const YY_NOEXCEPT
  {
    if (state == empty_state)
      return symbol_kind::S_YYEMPTY;
    else
      return YY_CAST (symbol_kind_type, yystos_[+state]);
  }

  BisonParser::stack_symbol_type::stack_symbol_type ()
  {}

  BisonParser::stack_symbol_type::stack_symbol_type (YY_RVREF (stack_symbol_type) that)
    : super_type (YY_MOVE (that.state), YY_MOVE (that.value), YY_MOVE (that.location))
  {
#if 201103L <= YY_CPLUSPLUS
    // that is emptied.
    that.state = empty_state;
#endif
  }

  BisonParser::stack_symbol_type::stack_symbol_type (state_type s, YY_MOVE_REF (symbol_type) that)
    : super_type (s, YY_MOVE (that.value), YY_MOVE (that.location))
  {
    // that is emptied.
    that.kind_ = symbol_kind::S_YYEMPTY;
  }

#if YY_CPLUSPLUS < 201103L
  BisonParser::stack_symbol_type&
  BisonParser::stack_symbol_type::operator= (const stack_symbol_type& that)
  {
    state = that.state;
    value = that.value;
    location = that.location;
    return *this;
  }

  BisonParser::stack_symbol_type&
  BisonParser::stack_symbol_type::operator= (stack_symbol_type& that)
  {
    state = that.state;
    value = that.value;
    location = that.location;
    // that is emptied.
    that.state = empty_state;
    return *this;
  }
#endif

  template <typename Base>
  void
  BisonParser::yy_destroy_ (const char* yymsg, basic_symbol<Base>& yysym) const
  {
    if (yymsg)
      YY_SYMBOL_PRINT (yymsg, yysym);

    // User destructor.
    YYUSE (yysym.kind ());
  }

#if YYDEBUG
  template <typename Base>
  void
  BisonParser::yy_print_ (std::ostream& yyo, const basic_symbol<Base>& yysym) const
  {
    std::ostream& yyoutput = yyo;
    YYUSE (yyoutput);
    if (yysym.empty ())
      yyo << "empty symbol";
    else
      {
        symbol_kind_type yykind = yysym.kind ();
        yyo << (yykind < YYNTOKENS ? "token" : "nterm")
            << ' ' << yysym.name () << " ("
            << yysym.location << ": ";
        YYUSE (yykind);
        yyo << ')';
      }
  }
#endif

  void
  BisonParser::yypush_ (const char* m, YY_MOVE_REF (stack_symbol_type) sym)
  {
    if (m)
      YY_SYMBOL_PRINT (m, sym);
    yystack_.push (YY_MOVE (sym));
  }

  void
  BisonParser::yypush_ (const char* m, state_type s, YY_MOVE_REF (symbol_type) sym)
  {
#if 201103L <= YY_CPLUSPLUS
    yypush_ (m, stack_symbol_type (s, std::move (sym)));
#else
    stack_symbol_type ss (s, sym);
    yypush_ (m, ss);
#endif
  }

  void
  BisonParser::yypop_ (int n)
  {
    yystack_.pop (n);
  }

#if YYDEBUG
  std::ostream&
  BisonParser::debug_stream () const
  {
    return *yycdebug_;
  }

  void
  BisonParser::set_debug_stream (std::ostream& o)
  {
    yycdebug_ = &o;
  }


  BisonParser::debug_level_type
  BisonParser::debug_level () const
  {
    return yydebug_;
  }

  void
  BisonParser::set_debug_level (debug_level_type l)
  {
    yydebug_ = l;
  }
#endif // YYDEBUG

  BisonParser::state_type
  BisonParser::yy_lr_goto_state_ (state_type yystate, int yysym)
  {
    int yyr = yypgoto_[yysym - YYNTOKENS] + yystate;
    if (0 <= yyr && yyr <= yylast_ && yycheck_[yyr] == yystate)
      return yytable_[yyr];
    else
      return yydefgoto_[yysym - YYNTOKENS];
  }

  bool
  BisonParser::yy_pact_value_is_default_ (int yyvalue)
  {
    return yyvalue == yypact_ninf_;
  }

  bool
  BisonParser::yy_table_value_is_error_ (int yyvalue)
  {
    return yyvalue == yytable_ninf_;
  }

  int
  BisonParser::operator() ()
  {
    return parse ();
  }

  int
  BisonParser::parse ()
  {
    int yyn;
    /// Length of the RHS of the rule being reduced.
    int yylen = 0;

    // Error handling.
    int yynerrs_ = 0;
    int yyerrstatus_ = 0;

    /// The lookahead symbol.
    symbol_type yyla;

    /// The locations where the error started and ended.
    stack_symbol_type yyerror_range[3];

    /// The return value of parse ().
    int yyresult;

#if YY_EXCEPTIONS
    try
#endif // YY_EXCEPTIONS
      {
    YYCDEBUG << "Starting parse\n";


    /* Initialize the stack.  The initial state will be set in
       yynewstate, since the latter expects the semantical and the
       location values to have been already stored, initialize these
       stacks with a primary value.  */
    yystack_.clear ();
    yypush_ (YY_NULLPTR, 0, YY_MOVE (yyla));

  /*-----------------------------------------------.
  | yynewstate -- push a new symbol on the stack.  |
  `-----------------------------------------------*/
  yynewstate:
    YYCDEBUG << "Entering state " << int (yystack_[0].state) << '\n';
    YY_STACK_PRINT ();

    // Accept?
    if (yystack_[0].state == yyfinal_)
      YYACCEPT;

    goto yybackup;


  /*-----------.
  | yybackup.  |
  `-----------*/
  yybackup:
    // Try to take a decision without lookahead.
    yyn = yypact_[+yystack_[0].state];
    if (yy_pact_value_is_default_ (yyn))
      goto yydefault;

    // Read a lookahead token.
    if (yyla.empty ())
      {
        YYCDEBUG << "Reading a token\n";
#if YY_EXCEPTIONS
        try
#endif // YY_EXCEPTIONS
          {
            yyla.kind_ = yytranslate_ (yylex (&yyla.value, &yyla.location, lexer));
          }
#if YY_EXCEPTIONS
        catch (const syntax_error& yyexc)
          {
            YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
            error (yyexc);
            goto yyerrlab1;
          }
#endif // YY_EXCEPTIONS
      }
    YY_SYMBOL_PRINT ("Next token is", yyla);

    if (yyla.kind () == symbol_kind::S_YYerror)
    {
      // The scanner already issued an error message, process directly
      // to error recovery.  But do not keep the error token as
      // lookahead, it is too special and may lead us to an endless
      // loop in error recovery. */
      yyla.kind_ = symbol_kind::S_YYUNDEF;
      goto yyerrlab1;
    }

    /* If the proper action on seeing token YYLA.TYPE is to reduce or
       to detect an error, take that action.  */
    yyn += yyla.kind ();
    if (yyn < 0 || yylast_ < yyn || yycheck_[yyn] != yyla.kind ())
      {
        goto yydefault;
      }

    // Reduce or error.
    yyn = yytable_[yyn];
    if (yyn <= 0)
      {
        if (yy_table_value_is_error_ (yyn))
          goto yyerrlab;
        yyn = -yyn;
        goto yyreduce;
      }

    // Count tokens shifted since error; after three, turn off error status.
    if (yyerrstatus_)
      --yyerrstatus_;

    // Shift the lookahead token.
    yypush_ ("Shifting", state_type (yyn), YY_MOVE (yyla));
    goto yynewstate;


  /*-----------------------------------------------------------.
  | yydefault -- do the default action for the current state.  |
  `-----------------------------------------------------------*/
  yydefault:
    yyn = yydefact_[+yystack_[0].state];
    if (yyn == 0)
      goto yyerrlab;
    goto yyreduce;


  /*-----------------------------.
  | yyreduce -- do a reduction.  |
  `-----------------------------*/
  yyreduce:
    yylen = yyr2_[yyn];
    {
      stack_symbol_type yylhs;
      yylhs.state = yy_lr_goto_state_ (yystack_[yylen].state, yyr1_[yyn]);
      /* If YYLEN is nonzero, implement the default value of the
         action: '$$ = $1'.  Otherwise, use the top of the stack.

         Otherwise, the following line sets YYLHS.VALUE to garbage.
         This behavior is undocumented and Bison users should not rely
         upon it.  */
      if (yylen)
        yylhs.value = yystack_[yylen - 1].value;
      else
        yylhs.value = yystack_[0].value;

      // Default location.
      {
        stack_type::slice range (yystack_, yylen);
        YYLLOC_DEFAULT (yylhs.location, range, yylen);
        yyerror_range[1].location = yylhs.location;
      }

      // Perform the reduction.
      YY_REDUCE_PRINT (yyn);
#if YY_EXCEPTIONS
      try
#endif // YY_EXCEPTIONS
        {
          switch (yyn)
            {
  case 2: // program: enter_statescope enter_varscope prog_decls exit_varscope exit_statescope
#line 133 "parser.yy"
    { parser.root_node_ = (yystack_[2].value.block); (yystack_[2].value.block)->scope_ = (yystack_[3].value.var_scope); }
#line 624 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 3: // prog_decls: prog_decl
#line 139 "parser.yy"
    { (yylhs.value.block) = new BlockStmtNode; (yylhs.value.block)->stmts_.push_back(StmtNode::Ptr((yystack_[0].value.stmt))); }
#line 630 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 4: // prog_decls: prog_decls prog_decl
#line 141 "parser.yy"
    { (yystack_[1].value.block)->stmts_.push_back(StmtNode::Ptr((yystack_[0].value.stmt))); }
#line 636 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 5: // prog_decl: var_decl TSEMI
#line 152 "parser.yy"
    { (yylhs.value.stmt) = (yystack_[1].value.stmt); }
#line 642 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 6: // prog_decl: struct_decl TSEMI
#line 153 "parser.yy"
    { (yylhs.value.stmt) = (yystack_[1].value.stmt); }
#line 648 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 7: // prog_decl: state_decl
#line 154 "parser.yy"
    { (yylhs.value.stmt) = (yystack_[0].value.stmt); }
#line 654 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 8: // prog_decl: table_decl TSEMI
#line 155 "parser.yy"
    { (yylhs.value.stmt) = (yystack_[1].value.stmt); }
#line 660 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 9: // prog_decl: pragma_decl
#line 156 "parser.yy"
    { (yylhs.value.stmt) = (yystack_[0].value.stmt); }
#line 666 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 10: // prog_decl: func_decl
#line 157 "parser.yy"
    { (yylhs.value.stmt) = (yystack_[0].value.stmt); }
#line 672 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 11: // pragma_decl: TPRAGMA TIDENTIFIER TIDENTIFIER
#line 162 "parser.yy"
    { (yylhs.value.stmt) = new BlockStmtNode; parser.add_pragma(*(yystack_[1].value.string), *(yystack_[0].value.string)); delete (yystack_[1].value.string); delete (yystack_[0].value.string); }
#line 678 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 12: // pragma_decl: TPRAGMA TIDENTIFIER TSTRING
#line 164 "parser.yy"
    { (yylhs.value.stmt) = new BlockStmtNode; parser.add_pragma(*(yystack_[1].value.string), *(yystack_[0].value.string)); delete (yystack_[1].value.string); delete (yystack_[0].value.string); }
#line 684 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 13: // stmts: stmt
#line 169 "parser.yy"
    { (yylhs.value.stmts) = new StmtNodeList; (yylhs.value.stmts)->push_back(StmtNode::Ptr((yystack_[0].value.stmt))); }
#line 690 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 14: // stmts: stmts stmt
#line 171 "parser.yy"
    { (yystack_[1].value.stmts)->push_back(StmtNode::Ptr((yystack_[0].value.stmt))); }
#line 696 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 15: // stmt: expr TSEMI
#line 176 "parser.yy"
    { (yylhs.value.stmt) = new ExprStmtNode(ExprNode::Ptr((yystack_[1].value.expr)));
      parser.set_loc((yylhs.value.stmt), yylhs.location); }
#line 703 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 16: // stmt: assign_expr TSEMI
#line 179 "parser.yy"
    { (yylhs.value.stmt) = new ExprStmtNode(ExprNode::Ptr((yystack_[1].value.expr)));
      parser.set_loc((yylhs.value.stmt), yylhs.location); }
#line 710 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 17: // stmt: return_expr TSEMI
#line 182 "parser.yy"
    { (yylhs.value.stmt) = new ExprStmtNode(ExprNode::Ptr((yystack_[1].value.expr)));
      parser.set_loc((yylhs.value.stmt), yylhs.location); }
#line 717 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 18: // stmt: call_expr TLBRACE enter_varscope table_result_stmts exit_varscope TRBRACE TSEMI
#line 185 "parser.yy"
    { (yylhs.value.stmt) = new ExprStmtNode(ExprNode::Ptr((yystack_[6].value.call)));
      (yystack_[6].value.call)->block_->stmts_ = move(*(yystack_[3].value.stmts)); delete (yystack_[3].value.stmts);
      (yystack_[6].value.call)->block_->scope_ = (yystack_[4].value.var_scope);
      parser.set_loc((yylhs.value.stmt), yylhs.location); }
#line 726 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 19: // stmt: call_expr TLBRACE TRBRACE TSEMI
#line 190 "parser.yy"
    { (yylhs.value.stmt) = new ExprStmtNode(ExprNode::Ptr((yystack_[3].value.call)));
      parser.set_loc((yylhs.value.stmt), yylhs.location); }
#line 733 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 20: // stmt: if_stmt
#line 192 "parser.yy"
    { (yylhs.value.stmt) = (yystack_[0].value.stmt); }
#line 739 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 21: // stmt: switch_stmt
#line 193 "parser.yy"
    { (yylhs.value.stmt) = (yystack_[0].value.stmt); }
#line 745 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 22: // stmt: var_decl TSEMI
#line 195 "parser.yy"
    { (yylhs.value.stmt) = (yystack_[1].value.stmt); }
#line 751 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 23: // stmt: state_decl
#line 196 "parser.yy"
    { (yylhs.value.stmt) = (yystack_[0].value.stmt); }
#line 757 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 24: // stmt: onvalid_stmt
#line 197 "parser.yy"
    { (yylhs.value.stmt) = (yystack_[0].value.stmt); }
#line 763 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 25: // call_expr: any_ident TLPAREN call_args TRPAREN
#line 202 "parser.yy"
    { (yylhs.value.call) = new MethodCallExprNode(IdentExprNode::Ptr((yystack_[3].value.ident)), move(*(yystack_[1].value.args)), lexer.lineno()); delete (yystack_[1].value.args);
      parser.set_loc((yylhs.value.call), yylhs.location); }
#line 770 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 26: // block: TLBRACE stmts TRBRACE
#line 208 "parser.yy"
    { (yylhs.value.block) = new BlockStmtNode; (yylhs.value.block)->stmts_ = move(*(yystack_[1].value.stmts)); delete (yystack_[1].value.stmts);
      parser.set_loc((yylhs.value.block), yylhs.location); }
#line 777 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 27: // block: TLBRACE TRBRACE
#line 211 "parser.yy"
    { (yylhs.value.block) = new BlockStmtNode;
      parser.set_loc((yylhs.value.block), yylhs.location); }
#line 784 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 28: // enter_varscope: %empty
#line 215 "parser.yy"
                             { (yylhs.value.var_scope) = parser.scopes_->enter_var_scope(); }
#line 790 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 29: // exit_varscope: %empty
#line 216 "parser.yy"
                            { (yylhs.value.var_scope) = parser.scopes_->exit_var_scope(); }
#line 796 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 30: // enter_statescope: %empty
#line 217 "parser.yy"
                               { (yylhs.value.state_scope) = parser.scopes_->enter_state_scope(); }
#line 802 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 31: // exit_statescope: %empty
#line 218 "parser.yy"
                              { (yylhs.value.state_scope) = parser.scopes_->exit_state_scope(); }
#line 808 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 32: // struct_decl: TSTRUCT ident TLBRACE struct_decl_stmts TRBRACE
#line 222 "parser.yy"
    { (yylhs.value.stmt) = parser.struct_add((yystack_[3].value.ident), (yystack_[1].value.formals)); delete (yystack_[1].value.formals);
      parser.set_loc((yylhs.value.stmt), yylhs.location); }
#line 815 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 33: // struct_decl_stmts: type_specifiers decl_stmt TSEMI
#line 228 "parser.yy"
    { (yylhs.value.formals) = new FormalList; (yylhs.value.formals)->push_back(VariableDeclStmtNode::Ptr((yystack_[1].value.decl))); }
#line 821 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 34: // struct_decl_stmts: struct_decl_stmts type_specifiers decl_stmt TSEMI
#line 230 "parser.yy"
    { (yystack_[3].value.formals)->push_back(VariableDeclStmtNode::Ptr((yystack_[1].value.decl))); }
#line 827 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 35: // table_decl: ident TCLT table_decl_args TCGT ident TLPAREN TINTEGER TRPAREN
#line 235 "parser.yy"
    { (yylhs.value.stmt) = parser.table_add((yystack_[7].value.ident), (yystack_[5].value.ident_args), (yystack_[3].value.ident), (yystack_[1].value.string)); delete (yystack_[5].value.ident_args);
      parser.set_loc((yylhs.value.stmt), yylhs.location); }
#line 834 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 36: // table_decl_args: ident
#line 241 "parser.yy"
    { (yylhs.value.ident_args) = new IdentExprNodeList; (yylhs.value.ident_args)->push_back(IdentExprNode::Ptr((yystack_[0].value.ident))); }
#line 840 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 37: // table_decl_args: table_decl_args TCOMMA ident
#line 243 "parser.yy"
    { (yylhs.value.ident_args)->push_back(IdentExprNode::Ptr((yystack_[0].value.ident))); }
#line 846 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 38: // state_decl: TSTATE scoped_ident enter_statescope enter_varscope block exit_varscope exit_statescope
#line 248 "parser.yy"
    { (yylhs.value.stmt) = parser.state_add((yystack_[4].value.state_scope), (yystack_[5].value.ident), (yystack_[2].value.block)); (yystack_[2].value.block)->scope_ = (yystack_[3].value.var_scope);
      if (!(yylhs.value.stmt)) YYERROR;
      parser.set_loc((yylhs.value.stmt), yylhs.location); }
#line 854 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 39: // state_decl: TSTATE scoped_ident TCOMMA TMUL enter_statescope enter_varscope block exit_varscope exit_statescope
#line 252 "parser.yy"
    { (yylhs.value.stmt) = parser.state_add((yystack_[4].value.state_scope), (yystack_[7].value.ident), new IdentExprNode(""), (yystack_[2].value.block)); (yystack_[2].value.block)->scope_ = (yystack_[3].value.var_scope);
      if (!(yylhs.value.stmt)) YYERROR;
      parser.set_loc((yylhs.value.stmt), yylhs.location); }
#line 862 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 40: // state_decl: TSTATE scoped_ident TCOMMA scoped_ident enter_statescope enter_varscope block exit_varscope exit_statescope
#line 256 "parser.yy"
    { (yylhs.value.stmt) = parser.state_add((yystack_[4].value.state_scope), (yystack_[7].value.ident), (yystack_[5].value.ident), (yystack_[2].value.block)); (yystack_[2].value.block)->scope_ = (yystack_[3].value.var_scope);
      if (!(yylhs.value.stmt)) YYERROR;
      parser.set_loc((yylhs.value.stmt), yylhs.location); }
#line 870 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 41: // func_decl: type_specifiers ident enter_statescope enter_varscope TLPAREN formals TRPAREN block exit_varscope exit_statescope
#line 263 "parser.yy"
    { (yylhs.value.stmt) = parser.func_add((yystack_[9].value.type_specifiers), (yystack_[7].value.state_scope), (yystack_[8].value.ident), (yystack_[4].value.formals), (yystack_[2].value.block)); (yystack_[2].value.block)->scope_ = (yystack_[6].value.var_scope);
      if (!(yylhs.value.stmt)) YYERROR;
      parser.set_loc((yylhs.value.stmt), yylhs.location); }
#line 878 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 42: // table_result_stmts: table_result_stmt
#line 270 "parser.yy"
    { (yylhs.value.stmts) = new StmtNodeList; (yylhs.value.stmts)->push_back(StmtNode::Ptr((yystack_[0].value.stmt))); }
#line 884 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 43: // table_result_stmts: table_result_stmts table_result_stmt
#line 272 "parser.yy"
    { (yylhs.value.stmts)->push_back(StmtNode::Ptr((yystack_[0].value.stmt))); }
#line 890 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 44: // table_result_stmt: TMATCH ident enter_varscope TLPAREN formals TRPAREN block exit_varscope TSEMI
#line 277 "parser.yy"
    { (yylhs.value.stmt) = parser.result_add((yystack_[8].value.token), (yystack_[7].value.ident), (yystack_[4].value.formals), (yystack_[2].value.block)); delete (yystack_[4].value.formals); (yystack_[2].value.block)->scope_ = (yystack_[6].value.var_scope);
      if (!(yylhs.value.stmt)) YYERROR;
      parser.set_loc((yylhs.value.stmt), yylhs.location); }
#line 898 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 45: // table_result_stmt: TMISS ident enter_varscope TLPAREN TRPAREN block exit_varscope TSEMI
#line 281 "parser.yy"
    { (yylhs.value.stmt) = parser.result_add((yystack_[7].value.token), (yystack_[6].value.ident), new FormalList, (yystack_[2].value.block)); (yystack_[2].value.block)->scope_ = (yystack_[5].value.var_scope);
      if (!(yylhs.value.stmt)) YYERROR;
      parser.set_loc((yylhs.value.stmt), yylhs.location); }
#line 906 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 46: // table_result_stmt: TFAILURE ident enter_varscope TLPAREN formals TRPAREN block exit_varscope TSEMI
#line 285 "parser.yy"
    { (yylhs.value.stmt) = parser.result_add((yystack_[8].value.token), (yystack_[7].value.ident), (yystack_[4].value.formals), (yystack_[2].value.block)); delete (yystack_[4].value.formals); (yystack_[2].value.block)->scope_ = (yystack_[6].value.var_scope);
      if (!(yylhs.value.stmt)) YYERROR;
      parser.set_loc((yylhs.value.stmt), yylhs.location); }
#line 914 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 47: // formals: TSTRUCT ptr_decl
#line 292 "parser.yy"
    { (yylhs.value.formals) = new FormalList; (yylhs.value.formals)->push_back(VariableDeclStmtNode::Ptr(parser.variable_add(nullptr, (yystack_[0].value.type_decl)))); }
#line 920 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 48: // formals: formals TCOMMA TSTRUCT ptr_decl
#line 294 "parser.yy"
    { (yystack_[3].value.formals)->push_back(VariableDeclStmtNode::Ptr(parser.variable_add(nullptr, (yystack_[0].value.type_decl)))); }
#line 926 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 49: // type_specifier: TU8
#line 298 "parser.yy"
    { (yylhs.value.token) = (yystack_[0].value.token); }
#line 932 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 50: // type_specifier: TU16
#line 299 "parser.yy"
    { (yylhs.value.token) = (yystack_[0].value.token); }
#line 938 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 51: // type_specifier: TU32
#line 300 "parser.yy"
    { (yylhs.value.token) = (yystack_[0].value.token); }
#line 944 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 52: // type_specifier: TU64
#line 301 "parser.yy"
    { (yylhs.value.token) = (yystack_[0].value.token); }
#line 950 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 53: // type_specifiers: type_specifier
#line 305 "parser.yy"
                   { (yylhs.value.type_specifiers) = new std::vector<int>; (yylhs.value.type_specifiers)->push_back((yystack_[0].value.token)); }
#line 956 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 54: // type_specifiers: type_specifiers type_specifier
#line 306 "parser.yy"
                                   { (yylhs.value.type_specifiers)->push_back((yystack_[0].value.token)); }
#line 962 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 55: // var_decl: type_specifiers decl_stmt
#line 311 "parser.yy"
    { (yylhs.value.stmt) = parser.variable_add((yystack_[1].value.type_specifiers), (yystack_[0].value.decl));
      if (!(yylhs.value.stmt)) YYERROR;
      parser.set_loc((yylhs.value.stmt), yylhs.location); }
#line 970 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 56: // var_decl: type_specifiers int_decl TEQUAL expr
#line 315 "parser.yy"
    { (yylhs.value.stmt) = parser.variable_add((yystack_[3].value.type_specifiers), (yystack_[2].value.decl), (yystack_[0].value.expr));
      if (!(yylhs.value.stmt)) YYERROR;
      parser.set_loc((yylhs.value.stmt), yylhs.location); }
#line 978 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 57: // var_decl: TSTRUCT type_decl TEQUAL TLBRACE init_args_kv TRBRACE
#line 319 "parser.yy"
    { (yylhs.value.stmt) = parser.variable_add((yystack_[4].value.type_decl), (yystack_[1].value.args), true);
      if (!(yylhs.value.stmt)) YYERROR;
      parser.set_loc((yylhs.value.stmt), yylhs.location); }
#line 986 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 58: // var_decl: TSTRUCT ref_stmt
#line 326 "parser.yy"
    { (yylhs.value.stmt) = parser.variable_add(nullptr, (yystack_[0].value.decl));
      if (!(yylhs.value.stmt)) YYERROR;
      parser.set_loc((yylhs.value.stmt), yylhs.location); }
#line 994 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 59: // decl_stmt: int_decl
#line 332 "parser.yy"
                     { (yylhs.value.decl) = (yystack_[0].value.decl); }
#line 1000 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 60: // decl_stmt: type_decl
#line 332 "parser.yy"
                                              { (yylhs.value.decl) = (yystack_[0].value.type_decl); }
#line 1006 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 61: // int_decl: ident TCOLON TINTEGER
#line 334 "parser.yy"
    { (yylhs.value.decl) = new IntegerVariableDeclStmtNode(IdentExprNode::Ptr((yystack_[2].value.ident)), *(yystack_[0].value.string)); delete (yystack_[0].value.string);
      parser.set_loc((yylhs.value.decl), yylhs.location); }
#line 1013 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 62: // type_decl: scoped_ident ident
#line 339 "parser.yy"
    { (yylhs.value.type_decl) = new StructVariableDeclStmtNode(IdentExprNode::Ptr((yystack_[1].value.ident)), IdentExprNode::Ptr((yystack_[0].value.ident)));
      parser.set_loc((yylhs.value.type_decl), yylhs.location); }
#line 1020 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 63: // ref_stmt: ptr_decl
#line 344 "parser.yy"
                    { (yylhs.value.decl) = (yystack_[0].value.type_decl); }
#line 1026 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 64: // ptr_decl: scoped_ident TMUL ident
#line 346 "parser.yy"
    { (yylhs.value.type_decl) = new StructVariableDeclStmtNode(IdentExprNode::Ptr((yystack_[2].value.ident)), IdentExprNode::Ptr((yystack_[0].value.ident)),
                                          VariableDeclStmtNode::STRUCT_REFERENCE);
      parser.set_loc((yylhs.value.type_decl), yylhs.location); }
#line 1034 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 65: // init_args_kv: init_arg_kv
#line 359 "parser.yy"
                { (yylhs.value.args) = new ExprNodeList; (yylhs.value.args)->push_back(ExprNode::Ptr((yystack_[0].value.expr))); }
#line 1040 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 66: // init_args_kv: init_args_kv TCOMMA init_arg_kv
#line 360 "parser.yy"
                                    { (yylhs.value.args)->push_back(ExprNode::Ptr((yystack_[0].value.expr))); }
#line 1046 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 67: // init_arg_kv: TDOT ident TEQUAL expr
#line 364 "parser.yy"
    { (yylhs.value.expr) = new AssignExprNode(IdentExprNode::Ptr((yystack_[2].value.ident)), ExprNode::Ptr((yystack_[0].value.expr)));
      parser.set_loc((yylhs.value.expr), yylhs.location); }
#line 1053 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 68: // init_arg_kv: TDOT ident bitop TEQUAL expr
#line 367 "parser.yy"
    { (yylhs.value.expr) = new AssignExprNode(IdentExprNode::Ptr((yystack_[3].value.ident)), ExprNode::Ptr((yystack_[0].value.expr))); (yylhs.value.expr)->bitop_ = BitopExprNode::Ptr((yystack_[2].value.bitop));
      parser.set_loc((yylhs.value.expr), yylhs.location); }
#line 1060 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 69: // if_stmt: TIF expr enter_varscope block exit_varscope
#line 373 "parser.yy"
    { (yylhs.value.stmt) = new IfStmtNode(ExprNode::Ptr((yystack_[3].value.expr)), StmtNode::Ptr((yystack_[1].value.block)));
      (yystack_[1].value.block)->scope_ = (yystack_[2].value.var_scope);
      parser.set_loc((yylhs.value.stmt), yylhs.location); }
#line 1068 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 70: // if_stmt: TIF expr enter_varscope block exit_varscope TELSE enter_varscope block exit_varscope
#line 377 "parser.yy"
    { (yylhs.value.stmt) = new IfStmtNode(ExprNode::Ptr((yystack_[7].value.expr)), StmtNode::Ptr((yystack_[5].value.block)), StmtNode::Ptr((yystack_[1].value.block)));
      (yystack_[5].value.block)->scope_ = (yystack_[6].value.var_scope); (yystack_[1].value.block)->scope_ = (yystack_[2].value.var_scope);
      parser.set_loc((yylhs.value.stmt), yylhs.location); }
#line 1076 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 71: // if_stmt: TIF expr enter_varscope block exit_varscope TELSE if_stmt
#line 381 "parser.yy"
    { (yylhs.value.stmt) = new IfStmtNode(ExprNode::Ptr((yystack_[5].value.expr)), StmtNode::Ptr((yystack_[3].value.block)), StmtNode::Ptr((yystack_[0].value.stmt)));
      (yystack_[3].value.block)->scope_ = (yystack_[4].value.var_scope);
      parser.set_loc((yylhs.value.stmt), yylhs.location); }
#line 1084 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 72: // onvalid_stmt: TVALID TLPAREN ident TRPAREN enter_varscope block exit_varscope
#line 388 "parser.yy"
    { (yylhs.value.stmt) = new OnValidStmtNode(IdentExprNode::Ptr((yystack_[4].value.ident)), StmtNode::Ptr((yystack_[1].value.block)));
      (yystack_[1].value.block)->scope_ = (yystack_[2].value.var_scope);
      parser.set_loc((yylhs.value.stmt), yylhs.location); }
#line 1092 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 73: // onvalid_stmt: TVALID TLPAREN ident TRPAREN enter_varscope block exit_varscope TELSE enter_varscope block exit_varscope
#line 392 "parser.yy"
    { (yylhs.value.stmt) = new OnValidStmtNode(IdentExprNode::Ptr((yystack_[8].value.ident)), StmtNode::Ptr((yystack_[5].value.block)), StmtNode::Ptr((yystack_[1].value.block)));
      (yystack_[5].value.block)->scope_ = (yystack_[6].value.var_scope); (yystack_[1].value.block)->scope_ = (yystack_[2].value.var_scope);
      parser.set_loc((yylhs.value.stmt), yylhs.location); }
#line 1100 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 74: // switch_stmt: TSWITCH expr TLBRACE case_stmts TRBRACE
#line 399 "parser.yy"
    { (yylhs.value.stmt) = new SwitchStmtNode(ExprNode::Ptr((yystack_[3].value.expr)), make_unique<BlockStmtNode>(move(*(yystack_[1].value.stmts)))); delete (yystack_[1].value.stmts);
      parser.set_loc((yylhs.value.stmt), yylhs.location); }
#line 1107 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 75: // case_stmts: case_stmt
#line 405 "parser.yy"
    { (yylhs.value.stmts) = new StmtNodeList; (yylhs.value.stmts)->push_back(StmtNode::Ptr((yystack_[0].value.stmt))); }
#line 1113 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 76: // case_stmts: case_stmts case_stmt
#line 407 "parser.yy"
    { (yylhs.value.stmts)->push_back(StmtNode::Ptr((yystack_[0].value.stmt))); }
#line 1119 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 77: // case_stmt: TCASE numeric block TSEMI
#line 412 "parser.yy"
    { (yylhs.value.stmt) = new CaseStmtNode(IntegerExprNode::Ptr((yystack_[2].value.numeric)), BlockStmtNode::Ptr((yystack_[1].value.block)));
      parser.set_loc((yylhs.value.stmt), yylhs.location); }
#line 1126 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 78: // case_stmt: TCASE TMUL block TSEMI
#line 415 "parser.yy"
    { (yylhs.value.stmt) = new CaseStmtNode(BlockStmtNode::Ptr((yystack_[1].value.block)));
      parser.set_loc((yylhs.value.stmt), yylhs.location); }
#line 1133 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 79: // numeric: TINTEGER
#line 421 "parser.yy"
    { (yylhs.value.numeric) = new IntegerExprNode((yystack_[0].value.string));
      parser.set_loc((yylhs.value.numeric), yylhs.location); }
#line 1140 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 80: // numeric: THEXINTEGER
#line 424 "parser.yy"
    { (yylhs.value.numeric) = new IntegerExprNode((yystack_[0].value.string));
      parser.set_loc((yylhs.value.numeric), yylhs.location); }
#line 1147 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 81: // numeric: TINTEGER TCOLON TINTEGER
#line 427 "parser.yy"
    { (yylhs.value.numeric) = new IntegerExprNode((yystack_[2].value.string), (yystack_[0].value.string));
      parser.set_loc((yylhs.value.numeric), yylhs.location); }
#line 1154 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 82: // numeric: THEXINTEGER TCOLON TINTEGER
#line 430 "parser.yy"
    { (yylhs.value.numeric) = new IntegerExprNode((yystack_[2].value.string), (yystack_[0].value.string));
      parser.set_loc((yylhs.value.numeric), yylhs.location); }
#line 1161 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 83: // numeric: TTRUE
#line 433 "parser.yy"
    { (yylhs.value.numeric) = new IntegerExprNode(new string("1"), new string("1"));
      parser.set_loc((yylhs.value.numeric), yylhs.location); }
#line 1168 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 84: // numeric: TFALSE
#line 436 "parser.yy"
    { (yylhs.value.numeric) = new IntegerExprNode(new string("0"), new string("1"));
      parser.set_loc((yylhs.value.numeric), yylhs.location); }
#line 1175 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 85: // assign_expr: expr TEQUAL expr
#line 442 "parser.yy"
    { (yylhs.value.expr) = new AssignExprNode(ExprNode::Ptr((yystack_[2].value.expr)), ExprNode::Ptr((yystack_[0].value.expr)));
      parser.set_loc((yylhs.value.expr), yylhs.location); }
#line 1182 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 86: // return_expr: TRETURN expr
#line 456 "parser.yy"
    { (yylhs.value.expr) = new ReturnExprNode(ExprNode::Ptr((yystack_[0].value.expr)));
      parser.set_loc((yylhs.value.expr), yylhs.location); }
#line 1189 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 87: // expr: call_expr
#line 462 "parser.yy"
    { (yylhs.value.expr) = (yystack_[0].value.call); }
#line 1195 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 88: // expr: call_expr bitop
#line 464 "parser.yy"
    { (yylhs.value.expr) = (yystack_[1].value.call); (yylhs.value.expr)->bitop_ = BitopExprNode::Ptr((yystack_[0].value.bitop)); }
#line 1201 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 89: // expr: table_index_expr
#line 466 "parser.yy"
    { (yylhs.value.expr) = (yystack_[0].value.table_index); }
#line 1207 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 90: // expr: table_index_expr TDOT ident
#line 468 "parser.yy"
    { (yylhs.value.expr) = (yystack_[2].value.table_index); (yystack_[2].value.table_index)->sub_ = IdentExprNode::Ptr((yystack_[0].value.ident)); }
#line 1213 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 91: // expr: any_ident
#line 470 "parser.yy"
    { (yylhs.value.expr) = (yystack_[0].value.ident); }
#line 1219 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 92: // expr: TAT dotted_ident
#line 472 "parser.yy"
    { (yylhs.value.expr) = new PacketExprNode(IdentExprNode::Ptr((yystack_[0].value.ident)));
      (yylhs.value.expr)->flags_[ExprNode::IS_REF] = true;
      parser.set_loc((yylhs.value.expr), yylhs.location); }
#line 1227 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 93: // expr: TDOLLAR dotted_ident
#line 476 "parser.yy"
    { (yylhs.value.expr) = new PacketExprNode(IdentExprNode::Ptr((yystack_[0].value.ident)));
      (yylhs.value.expr)->flags_[ExprNode::IS_PKT] = true;
      parser.set_loc((yylhs.value.expr), yylhs.location); }
#line 1235 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 94: // expr: TDOLLAR dotted_ident bitop
#line 480 "parser.yy"
    { (yylhs.value.expr) = new PacketExprNode(IdentExprNode::Ptr((yystack_[1].value.ident))); (yylhs.value.expr)->bitop_ = BitopExprNode::Ptr((yystack_[0].value.bitop));
      (yylhs.value.expr)->flags_[ExprNode::IS_PKT] = true;
      parser.set_loc((yylhs.value.expr), yylhs.location); }
#line 1243 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 95: // expr: TGOTO scoped_ident
#line 484 "parser.yy"
    { (yylhs.value.expr) = new GotoExprNode(IdentExprNode::Ptr((yystack_[0].value.ident)), false);
      parser.set_loc((yylhs.value.expr), yylhs.location); }
#line 1250 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 96: // expr: TNEXT scoped_ident
#line 487 "parser.yy"
    { (yylhs.value.expr) = new GotoExprNode(IdentExprNode::Ptr((yystack_[0].value.ident)), false);
      parser.set_loc((yylhs.value.expr), yylhs.location); }
#line 1257 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 97: // expr: TCONTINUE scoped_ident
#line 490 "parser.yy"
    { (yylhs.value.expr) = new GotoExprNode(IdentExprNode::Ptr((yystack_[0].value.ident)), true);
      parser.set_loc((yylhs.value.expr), yylhs.location); }
#line 1264 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 98: // expr: TLPAREN expr TRPAREN
#line 493 "parser.yy"
    { (yylhs.value.expr) = (yystack_[1].value.expr); }
#line 1270 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 99: // expr: TLPAREN expr TRPAREN bitop
#line 495 "parser.yy"
    { (yylhs.value.expr) = (yystack_[2].value.expr); (yylhs.value.expr)->bitop_ = BitopExprNode::Ptr((yystack_[0].value.bitop)); }
#line 1276 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 100: // expr: TSTRING
#line 497 "parser.yy"
    { (yylhs.value.expr) = new StringExprNode((yystack_[0].value.string));
      parser.set_loc((yylhs.value.expr), yylhs.location); }
#line 1283 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 101: // expr: numeric
#line 500 "parser.yy"
    { (yylhs.value.expr) = (yystack_[0].value.numeric); }
#line 1289 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 102: // expr: numeric bitop
#line 502 "parser.yy"
    { (yylhs.value.expr) = (yystack_[1].value.numeric); (yylhs.value.expr)->bitop_ = BitopExprNode::Ptr((yystack_[0].value.bitop)); }
#line 1295 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 103: // expr: expr TCLT expr
#line 504 "parser.yy"
    { (yylhs.value.expr) = new BinopExprNode(ExprNode::Ptr((yystack_[2].value.expr)), (yystack_[1].value.token), ExprNode::Ptr((yystack_[0].value.expr)));
      parser.set_loc((yylhs.value.expr), yylhs.location); }
#line 1302 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 104: // expr: expr TCGT expr
#line 507 "parser.yy"
    { (yylhs.value.expr) = new BinopExprNode(ExprNode::Ptr((yystack_[2].value.expr)), (yystack_[1].value.token), ExprNode::Ptr((yystack_[0].value.expr)));
      parser.set_loc((yylhs.value.expr), yylhs.location); }
#line 1309 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 105: // expr: expr TCGE expr
#line 510 "parser.yy"
    { (yylhs.value.expr) = new BinopExprNode(ExprNode::Ptr((yystack_[2].value.expr)), (yystack_[1].value.token), ExprNode::Ptr((yystack_[0].value.expr)));
      parser.set_loc((yylhs.value.expr), yylhs.location); }
#line 1316 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 106: // expr: expr TCLE expr
#line 513 "parser.yy"
    { (yylhs.value.expr) = new BinopExprNode(ExprNode::Ptr((yystack_[2].value.expr)), (yystack_[1].value.token), ExprNode::Ptr((yystack_[0].value.expr)));
      parser.set_loc((yylhs.value.expr), yylhs.location); }
#line 1323 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 107: // expr: expr TCNE expr
#line 516 "parser.yy"
    { (yylhs.value.expr) = new BinopExprNode(ExprNode::Ptr((yystack_[2].value.expr)), (yystack_[1].value.token), ExprNode::Ptr((yystack_[0].value.expr)));
      parser.set_loc((yylhs.value.expr), yylhs.location); }
#line 1330 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 108: // expr: expr TCEQ expr
#line 519 "parser.yy"
    { (yylhs.value.expr) = new BinopExprNode(ExprNode::Ptr((yystack_[2].value.expr)), (yystack_[1].value.token), ExprNode::Ptr((yystack_[0].value.expr)));
      parser.set_loc((yylhs.value.expr), yylhs.location); }
#line 1337 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 109: // expr: expr TPLUS expr
#line 522 "parser.yy"
    { (yylhs.value.expr) = new BinopExprNode(ExprNode::Ptr((yystack_[2].value.expr)), (yystack_[1].value.token), ExprNode::Ptr((yystack_[0].value.expr)));
      parser.set_loc((yylhs.value.expr), yylhs.location); }
#line 1344 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 110: // expr: expr TMINUS expr
#line 525 "parser.yy"
    { (yylhs.value.expr) = new BinopExprNode(ExprNode::Ptr((yystack_[2].value.expr)), (yystack_[1].value.token), ExprNode::Ptr((yystack_[0].value.expr)));
      parser.set_loc((yylhs.value.expr), yylhs.location); }
#line 1351 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 111: // expr: expr TMUL expr
#line 528 "parser.yy"
    { (yylhs.value.expr) = new BinopExprNode(ExprNode::Ptr((yystack_[2].value.expr)), (yystack_[1].value.token), ExprNode::Ptr((yystack_[0].value.expr)));
      parser.set_loc((yylhs.value.expr), yylhs.location); }
#line 1358 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 112: // expr: expr TDIV expr
#line 531 "parser.yy"
    { (yylhs.value.expr) = new BinopExprNode(ExprNode::Ptr((yystack_[2].value.expr)), (yystack_[1].value.token), ExprNode::Ptr((yystack_[0].value.expr)));
      parser.set_loc((yylhs.value.expr), yylhs.location); }
#line 1365 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 113: // expr: expr TMOD expr
#line 534 "parser.yy"
    { (yylhs.value.expr) = new BinopExprNode(ExprNode::Ptr((yystack_[2].value.expr)), (yystack_[1].value.token), ExprNode::Ptr((yystack_[0].value.expr)));
      parser.set_loc((yylhs.value.expr), yylhs.location); }
#line 1372 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 114: // expr: expr TXOR expr
#line 537 "parser.yy"
    { (yylhs.value.expr) = new BinopExprNode(ExprNode::Ptr((yystack_[2].value.expr)), (yystack_[1].value.token), ExprNode::Ptr((yystack_[0].value.expr)));
      parser.set_loc((yylhs.value.expr), yylhs.location); }
#line 1379 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 115: // expr: expr TAND expr
#line 540 "parser.yy"
    { (yylhs.value.expr) = new BinopExprNode(ExprNode::Ptr((yystack_[2].value.expr)), (yystack_[1].value.token), ExprNode::Ptr((yystack_[0].value.expr)));
      parser.set_loc((yylhs.value.expr), yylhs.location); }
#line 1386 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 116: // expr: expr TOR expr
#line 543 "parser.yy"
    { (yylhs.value.expr) = new BinopExprNode(ExprNode::Ptr((yystack_[2].value.expr)), (yystack_[1].value.token), ExprNode::Ptr((yystack_[0].value.expr)));
      parser.set_loc((yylhs.value.expr), yylhs.location); }
#line 1393 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 117: // expr: expr TLAND expr
#line 546 "parser.yy"
    { (yylhs.value.expr) = new BinopExprNode(ExprNode::Ptr((yystack_[2].value.expr)), (yystack_[1].value.token), ExprNode::Ptr((yystack_[0].value.expr)));
      parser.set_loc((yylhs.value.expr), yylhs.location); }
#line 1400 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 118: // expr: expr TLOR expr
#line 549 "parser.yy"
    { (yylhs.value.expr) = new BinopExprNode(ExprNode::Ptr((yystack_[2].value.expr)), (yystack_[1].value.token), ExprNode::Ptr((yystack_[0].value.expr)));
      parser.set_loc((yylhs.value.expr), yylhs.location); }
#line 1407 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 119: // expr: TNOT expr
#line 554 "parser.yy"
    { (yylhs.value.expr) = new UnopExprNode((yystack_[1].value.token), ExprNode::Ptr((yystack_[0].value.expr)));
      parser.set_loc((yylhs.value.expr), yylhs.location); }
#line 1414 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 120: // expr: TCMPL expr
#line 557 "parser.yy"
    { (yylhs.value.expr) = new UnopExprNode((yystack_[1].value.token), ExprNode::Ptr((yystack_[0].value.expr)));
      parser.set_loc((yylhs.value.expr), yylhs.location); }
#line 1421 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 121: // call_args: %empty
#line 563 "parser.yy"
    { (yylhs.value.args) = new ExprNodeList; }
#line 1427 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 122: // call_args: expr
#line 565 "parser.yy"
    { (yylhs.value.args) = new ExprNodeList; (yylhs.value.args)->push_back(ExprNode::Ptr((yystack_[0].value.expr))); }
#line 1433 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 123: // call_args: call_args TCOMMA expr
#line 567 "parser.yy"
    { (yylhs.value.args)->push_back(ExprNode::Ptr((yystack_[0].value.expr))); }
#line 1439 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 124: // bitop: TLBRACK TCOLON TPLUS TINTEGER TRBRACK
#line 572 "parser.yy"
    { (yylhs.value.bitop) = new BitopExprNode(string("0"), *(yystack_[1].value.string)); delete (yystack_[1].value.string);
      parser.set_loc((yylhs.value.bitop), yylhs.location); }
#line 1446 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 125: // bitop: TLBRACK TINTEGER TCOLON TPLUS TINTEGER TRBRACK
#line 575 "parser.yy"
    { (yylhs.value.bitop) = new BitopExprNode(*(yystack_[4].value.string), *(yystack_[1].value.string)); delete (yystack_[4].value.string); delete (yystack_[1].value.string);
      parser.set_loc((yylhs.value.bitop), yylhs.location); }
#line 1453 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 126: // table_index_expr: dotted_ident TLBRACK ident TRBRACK
#line 581 "parser.yy"
    { (yylhs.value.table_index) = new TableIndexExprNode(IdentExprNode::Ptr((yystack_[3].value.ident)), IdentExprNode::Ptr((yystack_[1].value.ident)));
      parser.set_loc((yylhs.value.table_index), yylhs.location); }
#line 1460 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 127: // scoped_ident: ident
#line 587 "parser.yy"
    { (yylhs.value.ident) = (yystack_[0].value.ident); }
#line 1466 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 128: // scoped_ident: scoped_ident TSCOPE TIDENTIFIER
#line 589 "parser.yy"
    { (yylhs.value.ident)->append_scope(*(yystack_[0].value.string)); delete (yystack_[0].value.string); }
#line 1472 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 129: // dotted_ident: ident
#line 594 "parser.yy"
    { (yylhs.value.ident) = (yystack_[0].value.ident); }
#line 1478 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 130: // dotted_ident: dotted_ident TDOT TIDENTIFIER
#line 596 "parser.yy"
    { (yylhs.value.ident)->append_dot(*(yystack_[0].value.string)); delete (yystack_[0].value.string); }
#line 1484 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 131: // any_ident: ident
#line 601 "parser.yy"
    { (yylhs.value.ident) = (yystack_[0].value.ident); }
#line 1490 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 132: // any_ident: dotted_ident TARROW TIDENTIFIER
#line 603 "parser.yy"
    { (yylhs.value.ident)->append_dot(*(yystack_[0].value.string)); delete (yystack_[0].value.string); }
#line 1496 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 133: // any_ident: dotted_ident TDOT TIDENTIFIER
#line 605 "parser.yy"
    { (yylhs.value.ident)->append_dot(*(yystack_[0].value.string)); delete (yystack_[0].value.string); }
#line 1502 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 134: // any_ident: scoped_ident TSCOPE TIDENTIFIER
#line 607 "parser.yy"
    { (yylhs.value.ident)->append_scope(*(yystack_[0].value.string)); delete (yystack_[0].value.string); }
#line 1508 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;

  case 135: // ident: TIDENTIFIER
#line 612 "parser.yy"
    { (yylhs.value.ident) = new IdentExprNode(*(yystack_[0].value.string)); delete (yystack_[0].value.string);
      parser.set_loc((yylhs.value.ident), yylhs.location); }
#line 1515 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"
    break;


#line 1519 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"

            default:
              break;
            }
        }
#if YY_EXCEPTIONS
      catch (const syntax_error& yyexc)
        {
          YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
          error (yyexc);
          YYERROR;
        }
#endif // YY_EXCEPTIONS
      YY_SYMBOL_PRINT ("-> $$ =", yylhs);
      yypop_ (yylen);
      yylen = 0;

      // Shift the result of the reduction.
      yypush_ (YY_NULLPTR, YY_MOVE (yylhs));
    }
    goto yynewstate;


  /*--------------------------------------.
  | yyerrlab -- here on detecting error.  |
  `--------------------------------------*/
  yyerrlab:
    // If not already recovering from an error, report this error.
    if (!yyerrstatus_)
      {
        ++yynerrs_;
        std::string msg = YY_("syntax error");
        error (yyla.location, YY_MOVE (msg));
      }


    yyerror_range[1].location = yyla.location;
    if (yyerrstatus_ == 3)
      {
        /* If just tried and failed to reuse lookahead token after an
           error, discard it.  */

        // Return failure if at end of input.
        if (yyla.kind () == symbol_kind::S_YYEOF)
          YYABORT;
        else if (!yyla.empty ())
          {
            yy_destroy_ ("Error: discarding", yyla);
            yyla.clear ();
          }
      }

    // Else will try to reuse lookahead token after shifting the error token.
    goto yyerrlab1;


  /*---------------------------------------------------.
  | yyerrorlab -- error raised explicitly by YYERROR.  |
  `---------------------------------------------------*/
  yyerrorlab:
    /* Pacify compilers when the user code never invokes YYERROR and
       the label yyerrorlab therefore never appears in user code.  */
    if (false)
      YYERROR;

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYERROR.  */
    yypop_ (yylen);
    yylen = 0;
    YY_STACK_PRINT ();
    goto yyerrlab1;


  /*-------------------------------------------------------------.
  | yyerrlab1 -- common code for both syntax error and YYERROR.  |
  `-------------------------------------------------------------*/
  yyerrlab1:
    yyerrstatus_ = 3;   // Each real token shifted decrements this.
    // Pop stack until we find a state that shifts the error token.
    for (;;)
      {
        yyn = yypact_[+yystack_[0].state];
        if (!yy_pact_value_is_default_ (yyn))
          {
            yyn += symbol_kind::S_YYerror;
            if (0 <= yyn && yyn <= yylast_
                && yycheck_[yyn] == symbol_kind::S_YYerror)
              {
                yyn = yytable_[yyn];
                if (0 < yyn)
                  break;
              }
          }

        // Pop the current state because it cannot handle the error token.
        if (yystack_.size () == 1)
          YYABORT;

        yyerror_range[1].location = yystack_[0].location;
        yy_destroy_ ("Error: popping", yystack_[0]);
        yypop_ ();
        YY_STACK_PRINT ();
      }
    {
      stack_symbol_type error_token;

      yyerror_range[2].location = yyla.location;
      YYLLOC_DEFAULT (error_token.location, yyerror_range, 2);

      // Shift the error token.
      error_token.state = state_type (yyn);
      yypush_ ("Shifting", YY_MOVE (error_token));
    }
    goto yynewstate;


  /*-------------------------------------.
  | yyacceptlab -- YYACCEPT comes here.  |
  `-------------------------------------*/
  yyacceptlab:
    yyresult = 0;
    goto yyreturn;


  /*-----------------------------------.
  | yyabortlab -- YYABORT comes here.  |
  `-----------------------------------*/
  yyabortlab:
    yyresult = 1;
    goto yyreturn;


  /*-----------------------------------------------------.
  | yyreturn -- parsing is finished, return the result.  |
  `-----------------------------------------------------*/
  yyreturn:
    if (!yyla.empty ())
      yy_destroy_ ("Cleanup: discarding lookahead", yyla);

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYABORT or YYACCEPT.  */
    yypop_ (yylen);
    YY_STACK_PRINT ();
    while (1 < yystack_.size ())
      {
        yy_destroy_ ("Cleanup: popping", yystack_[0]);
        yypop_ ();
      }

    return yyresult;
  }
#if YY_EXCEPTIONS
    catch (...)
      {
        YYCDEBUG << "Exception caught: cleaning lookahead and stack\n";
        // Do not try to display the values of the reclaimed symbols,
        // as their printers might throw an exception.
        if (!yyla.empty ())
          yy_destroy_ (YY_NULLPTR, yyla);

        while (1 < yystack_.size ())
          {
            yy_destroy_ (YY_NULLPTR, yystack_[0]);
            yypop_ ();
          }
        throw;
      }
#endif // YY_EXCEPTIONS
  }

  void
  BisonParser::error (const syntax_error& yyexc)
  {
    error (yyexc.location, yyexc.what ());
  }

#if YYDEBUG || 0
  const char *
  BisonParser::symbol_name (symbol_kind_type yysymbol)
  {
    return yytname_[yysymbol];
  }
#endif // #if YYDEBUG || 0





  const short BisonParser::yypact_ninf_ = -184;

  const short BisonParser::yytable_ninf_ = -131;

  const short
  BisonParser::yypact_[] =
  {
    -184,    35,  -184,  -184,   182,  -184,    49,  -184,  -184,  -184,
    -184,   116,   116,   182,  -184,  -184,    84,   105,  -184,  -184,
    -184,   277,   106,    48,   141,   142,  -184,  -184,    16,   134,
      52,  -184,  -184,  -184,  -184,  -184,  -184,  -184,   149,  -184,
      18,     7,  -184,   116,  -184,  -184,   161,   116,   184,  -184,
     303,    23,  -184,  -184,    90,   190,  -184,    13,  -184,   171,
    -184,  -184,   206,   277,  -184,   174,   186,   181,   188,  -184,
      90,   116,    90,    90,   116,   116,   116,  -184,  -184,   116,
     196,   196,   457,   201,   198,   223,   218,   207,  -184,   219,
     116,   116,   116,   104,  -184,  -184,   277,   202,  -184,   209,
    -184,  -184,   255,  -184,   240,   249,   395,   125,  -184,   457,
     457,   174,   174,   174,   234,    14,  -184,  -184,    90,    90,
      90,    90,    90,    90,    90,    90,    90,    90,    90,    90,
      90,    90,    90,    90,   116,   264,   116,   267,   268,    90,
     230,   257,  -184,    20,  -184,   171,   241,  -184,   186,   186,
    -184,   116,    90,    90,    90,   261,   314,  -184,    66,  -184,
     277,   243,  -184,  -184,  -184,   258,   269,   364,  -184,  -184,
    -184,   196,   286,  -184,   260,   271,   595,    65,   578,   578,
     578,   578,    60,    92,   559,   568,   488,   519,   528,   177,
     252,  -184,  -184,   282,   300,   265,  -184,   457,     9,   116,
      11,   323,    90,   316,  -184,  -184,  -184,  -184,   457,   457,
     426,   116,  -184,  -184,   305,  -184,  -184,  -184,    90,  -184,
    -184,  -184,  -184,   301,   326,  -184,  -184,    90,  -184,    89,
     186,   288,   311,   457,    90,  -184,  -184,   186,   278,   315,
     296,   108,   457,   335,   317,   457,  -184,   116,  -184,   457,
    -184,  -184,  -184,    64,     5,  -184,  -184,  -184,   116,   116,
     116,   108,  -184,   318,  -184,  -184,  -184,   287,   186,   186,
    -184,  -184,   186,  -184,  -184,  -184,   321,  -184,  -184,  -184,
     289,   306,   307,  -184,   319,   327,   328,   312,   186,  -184,
    -184,  -184,   297,   230,   332,   230,  -184,  -184,  -184,    12,
     186,    77,  -184,   186,   186,  -184,   186,  -184,  -184,   320,
    -184,  -184,   330,  -184,   331,  -184,  -184
  };

  const unsigned char
  BisonParser::yydefact_[] =
  {
      30,     0,    28,     1,     0,   135,     0,    49,    50,    51,
      52,     0,     0,    29,     3,     9,     0,     0,     7,    10,
      53,     0,     0,     0,     0,     0,    58,    63,     0,   127,
      30,   127,     4,    31,     6,     8,    54,    55,    59,    60,
       0,   127,     5,     0,    11,    12,     0,     0,     0,    62,
       0,     0,    28,     2,     0,     0,    28,     0,    36,     0,
      64,   128,     0,     0,    30,    30,     0,    79,    80,   100,
       0,     0,     0,     0,     0,     0,     0,    83,    84,     0,
      87,   101,    56,    89,     0,     0,    91,   131,    61,     0,
       0,     0,     0,     0,    65,    32,     0,     0,    59,   127,
      28,    28,     0,    29,     0,     0,     0,    93,   129,   119,
     120,    95,    97,    96,    92,     0,    88,   102,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   121,
       0,     0,    37,     0,    57,     0,     0,    33,     0,     0,
      27,     0,     0,     0,     0,     0,     0,    13,    87,    23,
       0,     0,    20,    24,    21,     0,     0,     0,    31,    81,
      82,    98,     0,    94,     0,     0,   108,   107,   103,   106,
     104,   105,   115,   116,   109,   110,   111,   112,   113,   114,
     117,   118,    90,   134,     0,   133,   132,   122,     0,     0,
       0,     0,     0,     0,    66,    34,    29,    29,    86,    28,
       0,     0,    26,    14,    28,    22,    16,    17,     0,    15,
      38,    99,   130,     0,     0,   126,    25,     0,    47,     0,
       0,     0,     0,    67,     0,    31,    31,     0,     0,     0,
       0,     0,    85,     0,     0,   123,    29,     0,    35,    68,
      39,    40,    29,     0,     0,    75,    28,    19,     0,     0,
       0,    29,    42,     0,   124,    31,    48,    69,     0,     0,
      74,    76,     0,    28,    28,    28,     0,    43,   125,    41,
      28,     0,     0,    29,     0,     0,     0,     0,     0,    71,
      78,    77,    72,     0,     0,     0,    18,    29,    28,     0,
       0,     0,    70,     0,     0,    29,     0,    29,    29,     0,
      29,    73,     0,    45,     0,    44,    46
  };

  const short
  BisonParser::yypgoto_[] =
  {
    -184,  -184,  -184,   343,  -184,  -184,   212,   -99,   -31,   -51,
     -97,    95,  -153,  -184,  -184,  -184,  -184,   -90,  -184,  -184,
      96,   -62,   -17,   -40,   -82,   -38,   -36,    -9,  -184,  -183,
    -184,   227,    93,  -184,  -184,  -184,   131,   133,  -184,  -184,
      50,  -184,   -70,  -184,     2,    34,  -184,    -4
  };

  const short
  BisonParser::yydefgoto_[] =
  {
      -1,     1,    13,    14,    15,   156,   157,    80,   103,     4,
      33,     2,    53,    16,    62,    17,    57,    18,    19,   261,
     262,   200,    20,    21,    22,    37,    38,    39,    26,    27,
      93,    94,   162,   163,   164,   254,   255,    81,   165,   166,
     167,   198,   116,    83,    84,    85,    86,    87
  };

  const short
  BisonParser::yytable_[] =
  {
      23,    66,    25,   158,    36,    89,   168,    29,    31,    23,
      63,   117,   159,    28,    30,   220,   228,    41,   174,     5,
     161,     5,    96,    40,    49,    97,     5,    98,   -30,   270,
      90,   226,   202,   230,   304,     3,    49,   173,   227,    58,
     231,   231,    91,    60,    55,   115,    36,    31,    47,   148,
     149,   175,    24,    65,    48,    64,    48,   158,   146,    99,
      98,   253,   160,    43,   266,    40,   159,   108,    67,    68,
      31,    31,    31,   203,   161,   108,   111,   112,   113,    36,
     125,    51,   250,   251,   124,   125,   141,   142,   143,   214,
      48,   115,    99,     5,    67,    68,   268,    69,    40,   306,
     131,   221,   132,   133,    82,   107,   231,   132,   133,   235,
     236,    70,   279,   114,    77,    78,   160,   206,   207,     5,
     106,    47,   109,   110,    34,    52,    71,    48,   144,    72,
     192,    73,   194,   145,   132,   133,    56,    74,    75,    76,
      77,    78,    25,    36,    44,    35,    42,    31,    45,   265,
     115,    79,   172,    28,    46,   267,    99,    50,   237,   100,
     101,    54,    40,   241,   276,   258,   259,   260,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,    59,     5,   292,    61,     6,   197,
       7,     8,     9,    10,    88,    31,   124,   125,    92,   246,
     302,   229,   208,   209,   210,   272,   252,   239,   309,   102,
     311,   312,    48,   314,     7,     8,     9,    10,   104,   132,
     133,   115,   284,   285,   286,   105,    11,    12,   134,   288,
      95,   299,  -129,   301,  -129,  -129,   135,   281,   282,   139,
     140,   283,   147,    31,   169,  -127,    55,   303,   136,   229,
     137,   138,   233,   170,   273,   274,   275,   297,     5,    67,
      68,   172,    69,     7,     8,     9,    10,   193,   242,   305,
     195,   196,   307,   308,   199,   310,    70,   245,   201,   150,
       5,   205,   211,   215,   249,     7,     8,     9,    10,   222,
    -130,    71,  -130,  -130,    72,   133,    73,   223,   216,   151,
      12,   224,    74,    75,    76,    77,    78,   152,   153,   217,
     154,     7,     8,     9,    10,   155,    79,     5,    67,    68,
    -128,    69,     7,     8,     9,    10,   225,   232,   234,   240,
     244,   243,   247,   248,   253,    70,   257,   256,   212,   263,
     293,   280,   153,   264,   278,   287,   290,   291,   294,   295,
      71,   298,   296,    72,   300,    73,    32,   277,   151,    12,
     313,    74,    75,    76,    77,    78,   152,   153,   213,   154,
     315,   316,   204,   289,   155,    79,   218,   118,   119,   120,
     121,   122,   123,   124,   125,   271,   269,     0,     0,     0,
       0,     0,     0,     0,   126,   127,   128,   129,   130,   131,
       0,     0,     0,     0,   219,     0,   132,   133,   118,   119,
     120,   121,   122,   123,   124,   125,     0,   171,     0,     0,
       0,     0,     0,     0,     0,   126,   127,   128,   129,   130,
     131,     0,     0,     0,     0,     0,     0,   132,   133,   118,
     119,   120,   121,   122,   123,   124,   125,     0,     0,   238,
       0,     0,     0,     0,     0,     0,   126,   127,   128,   129,
     130,   131,     0,     0,     0,     0,     0,     0,   132,   133,
     118,   119,   120,   121,   122,   123,   124,   125,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   126,   127,   128,
     129,   130,   131,     0,     0,     0,     0,     0,     0,   132,
     133,   118,   119,   120,   121,   122,   123,   124,   125,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   126,   127,
       0,   129,   130,   131,     0,     0,     0,     0,     0,     0,
     132,   133,   118,   119,   120,   121,   122,   123,   124,   125,
       0,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,     0,     0,   130,   131,     0,     0,     0,   126,   127,
       0,   132,   133,   131,     0,     0,     0,     0,     0,     0,
     132,   133,   118,   119,   120,   121,   122,   123,   124,   125,
       0,   118,   119,   120,   121,   122,   123,   124,   125,     0,
     127,   118,   119,     0,   131,     0,     0,   124,   125,     0,
       0,   132,   133,   131,     0,     0,     0,     0,     0,   119,
     132,   133,     0,   131,   124,   125,     0,     0,     0,     0,
     132,   133,     0,     0,     0,     0,     0,     0,     0,     0,
     131,     0,     0,     0,     0,     0,     0,   132,   133
  };

  const short
  BisonParser::yycheck_[] =
  {
       4,    52,    11,   102,    21,    56,   103,    11,    12,    13,
      50,    81,   102,    11,    12,   168,   199,    21,     4,     3,
     102,     3,    62,    21,    28,    63,     3,    63,    21,    24,
      17,    22,    12,    22,    22,     0,    40,   107,    29,    43,
      29,    29,    29,    47,    37,    25,    63,    51,    32,   100,
     101,    37,     3,    51,    38,    32,    38,   156,    96,    63,
      96,    56,   102,    15,   247,    63,   156,    71,     4,     5,
      74,    75,    76,   143,   156,    79,    74,    75,    76,    96,
      20,    29,   235,   236,    19,    20,    90,    91,    92,    23,
      38,    25,    96,     3,     4,     5,    32,     7,    96,    22,
      35,   171,    42,    43,    54,    71,    29,    42,    43,   206,
     207,    21,   265,    79,    50,    51,   156,   148,   149,     3,
      70,    32,    72,    73,    40,    30,    36,    38,    24,    39,
     134,    41,   136,    29,    42,    43,    41,    47,    48,    49,
      50,    51,   151,   160,     3,    40,    40,   151,     7,   246,
      25,    61,    27,   151,    12,   252,   160,    23,   209,    64,
      65,    12,   160,   214,   261,    57,    58,    59,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,    23,     3,   283,     3,     6,   139,
       8,     9,    10,    11,     4,   199,    19,    20,    27,   230,
     297,   199,   152,   153,   154,   256,   237,   211,   305,    23,
     307,   308,    38,   310,     8,     9,    10,    11,    37,    42,
      43,    25,   273,   274,   275,    37,    44,    45,    27,   280,
      24,   293,    25,   295,    27,    28,    38,   268,   269,    21,
      21,   272,    40,   247,     4,    38,    37,   298,    25,   247,
      27,    28,   202,     4,   258,   259,   260,   288,     3,     4,
       5,    27,     7,     8,     9,    10,    11,     3,   218,   300,
       3,     3,   303,   304,    44,   306,    21,   227,    21,    24,
       3,    40,    21,    40,   234,     8,     9,    10,    11,     3,
      25,    36,    27,    28,    39,    43,    41,    37,    40,    44,
      45,    30,    47,    48,    49,    50,    51,    52,    53,    40,
      55,     8,     9,    10,    11,    60,    61,     3,     4,     5,
      38,     7,     8,     9,    10,    11,    26,     4,    12,    24,
       4,    30,    44,    22,    56,    21,    40,    22,    24,     4,
      21,    54,    53,    26,    26,    24,    40,    40,    21,    21,
      36,    54,    40,    39,    22,    41,    13,   261,    44,    45,
      40,    47,    48,    49,    50,    51,    52,    53,   156,    55,
      40,    40,   145,   280,    60,    61,    12,    13,    14,    15,
      16,    17,    18,    19,    20,   254,   253,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    30,    31,    32,    33,    34,    35,
      -1,    -1,    -1,    -1,    40,    -1,    42,    43,    13,    14,
      15,    16,    17,    18,    19,    20,    -1,    22,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    30,    31,    32,    33,    34,
      35,    -1,    -1,    -1,    -1,    -1,    -1,    42,    43,    13,
      14,    15,    16,    17,    18,    19,    20,    -1,    -1,    23,
      -1,    -1,    -1,    -1,    -1,    -1,    30,    31,    32,    33,
      34,    35,    -1,    -1,    -1,    -1,    -1,    -1,    42,    43,
      13,    14,    15,    16,    17,    18,    19,    20,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    30,    31,    32,
      33,    34,    35,    -1,    -1,    -1,    -1,    -1,    -1,    42,
      43,    13,    14,    15,    16,    17,    18,    19,    20,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    30,    31,
      -1,    33,    34,    35,    -1,    -1,    -1,    -1,    -1,    -1,
      42,    43,    13,    14,    15,    16,    17,    18,    19,    20,
      -1,    13,    14,    15,    16,    17,    18,    19,    20,    30,
      31,    -1,    -1,    34,    35,    -1,    -1,    -1,    30,    31,
      -1,    42,    43,    35,    -1,    -1,    -1,    -1,    -1,    -1,
      42,    43,    13,    14,    15,    16,    17,    18,    19,    20,
      -1,    13,    14,    15,    16,    17,    18,    19,    20,    -1,
      31,    13,    14,    -1,    35,    -1,    -1,    19,    20,    -1,
      -1,    42,    43,    35,    -1,    -1,    -1,    -1,    -1,    14,
      42,    43,    -1,    35,    19,    20,    -1,    -1,    -1,    -1,
      42,    43,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      35,    -1,    -1,    -1,    -1,    -1,    -1,    42,    43
  };

  const signed char
  BisonParser::yystos_[] =
  {
       0,    65,    75,     0,    73,     3,     6,     8,     9,    10,
      11,    44,    45,    66,    67,    68,    77,    79,    81,    82,
      86,    87,    88,   111,     3,    91,    92,    93,   108,   111,
     108,   111,    67,    74,    40,    40,    86,    89,    90,    91,
     108,   111,    40,    15,     3,     7,    12,    32,    38,   111,
      23,    29,    75,    76,    12,    37,    75,    80,   111,    23,
     111,     3,    78,    87,    32,   108,    73,     4,     5,     7,
      21,    36,    39,    41,    47,    48,    49,    50,    51,    61,
      71,   101,   104,   107,   108,   109,   110,   111,     4,    73,
      17,    29,    27,    94,    95,    24,    87,    89,    90,   111,
      75,    75,    23,    72,    37,    37,   104,   109,   111,   104,
     104,   108,   108,   108,   109,    25,   106,   106,    13,    14,
      15,    16,    17,    18,    19,    20,    30,    31,    32,    33,
      34,    35,    42,    43,    27,    38,    25,    27,    28,    21,
      21,   111,   111,   111,    24,    29,    89,    40,    73,    73,
      24,    44,    52,    53,    55,    60,    69,    70,    71,    81,
      87,    88,    96,    97,    98,   102,   103,   104,    74,     4,
       4,    22,    27,   106,     4,    37,   104,   104,   104,   104,
     104,   104,   104,   104,   104,   104,   104,   104,   104,   104,
     104,   104,   111,     3,   111,     3,     3,   104,   105,    44,
      85,    21,    12,   106,    95,    40,    72,    72,   104,   104,
     104,    21,    24,    70,    23,    40,    40,    40,    12,    40,
      76,   106,     3,    37,    30,    26,    22,    29,    93,   108,
      22,    29,     4,   104,    12,    74,    74,    73,    23,   111,
      24,    73,   104,    30,     4,   104,    72,    44,    22,   104,
      76,    76,    72,    56,    99,   100,    22,    40,    57,    58,
      59,    83,    84,     4,    26,    74,    93,    74,    32,   101,
      24,   100,    73,   111,   111,   111,    74,    84,    26,    76,
      54,    72,    72,    72,    73,    73,    73,    24,    73,    96,
      40,    40,    74,    21,    21,    21,    40,    72,    54,    85,
      22,    85,    74,    73,    22,    72,    22,    72,    72,    74,
      72,    74,    74,    40,    74,    40,    40
  };

  const signed char
  BisonParser::yyr1_[] =
  {
       0,    64,    65,    66,    66,    67,    67,    67,    67,    67,
      67,    68,    68,    69,    69,    70,    70,    70,    70,    70,
      70,    70,    70,    70,    70,    71,    72,    72,    73,    74,
      75,    76,    77,    78,    78,    79,    80,    80,    81,    81,
      81,    82,    83,    83,    84,    84,    84,    85,    85,    86,
      86,    86,    86,    87,    87,    88,    88,    88,    88,    89,
      89,    90,    91,    92,    93,    94,    94,    95,    95,    96,
      96,    96,    97,    97,    98,    99,    99,   100,   100,   101,
     101,   101,   101,   101,   101,   102,   103,   104,   104,   104,
     104,   104,   104,   104,   104,   104,   104,   104,   104,   104,
     104,   104,   104,   104,   104,   104,   104,   104,   104,   104,
     104,   104,   104,   104,   104,   104,   104,   104,   104,   104,
     104,   105,   105,   105,   106,   106,   107,   108,   108,   109,
     109,   110,   110,   110,   110,   111
  };

  const signed char
  BisonParser::yyr2_[] =
  {
       0,     2,     5,     1,     2,     2,     2,     1,     2,     1,
       1,     3,     3,     1,     2,     2,     2,     2,     7,     4,
       1,     1,     2,     1,     1,     4,     3,     2,     0,     0,
       0,     0,     5,     3,     4,     8,     1,     3,     7,     9,
       9,    10,     1,     2,     9,     8,     9,     2,     4,     1,
       1,     1,     1,     1,     2,     2,     4,     6,     2,     1,
       1,     3,     2,     1,     3,     1,     3,     4,     5,     5,
       9,     7,     7,    11,     5,     1,     2,     4,     4,     1,
       1,     3,     3,     1,     1,     3,     2,     1,     2,     1,
       3,     1,     2,     2,     3,     2,     2,     2,     3,     4,
       1,     1,     2,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     2,
       2,     0,     1,     3,     5,     6,     4,     1,     3,     1,
       3,     1,     3,     3,     3,     1
  };


#if YYDEBUG
  // YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
  // First, the terminals, then, starting at \a YYNTOKENS, nonterminals.
  const char*
  const BisonParser::yytname_[] =
  {
  "\"end of file\"", "error", "\"invalid token\"", "TIDENTIFIER",
  "TINTEGER", "THEXINTEGER", "TPRAGMA", "TSTRING", "TU8", "TU16", "TU32",
  "TU64", "TEQUAL", "TCEQ", "TCNE", "TCLT", "TCLE", "TCGT", "TCGE", "TAND",
  "TOR", "TLPAREN", "TRPAREN", "TLBRACE", "TRBRACE", "TLBRACK", "TRBRACK",
  "TDOT", "TARROW", "TCOMMA", "TPLUS", "TMINUS", "TMUL", "TDIV", "TMOD",
  "TXOR", "TDOLLAR", "TCOLON", "TSCOPE", "TNOT", "TSEMI", "TCMPL", "TLAND",
  "TLOR", "TSTRUCT", "TSTATE", "TFUNC", "TGOTO", "TCONTINUE", "TNEXT",
  "TTRUE", "TFALSE", "TRETURN", "TIF", "TELSE", "TSWITCH", "TCASE",
  "TMATCH", "TMISS", "TFAILURE", "TVALID", "TAT", "TINCR", "TDECR",
  "$accept", "program", "prog_decls", "prog_decl", "pragma_decl", "stmts",
  "stmt", "call_expr", "block", "enter_varscope", "exit_varscope",
  "enter_statescope", "exit_statescope", "struct_decl",
  "struct_decl_stmts", "table_decl", "table_decl_args", "state_decl",
  "func_decl", "table_result_stmts", "table_result_stmt", "formals",
  "type_specifier", "type_specifiers", "var_decl", "decl_stmt", "int_decl",
  "type_decl", "ref_stmt", "ptr_decl", "init_args_kv", "init_arg_kv",
  "if_stmt", "onvalid_stmt", "switch_stmt", "case_stmts", "case_stmt",
  "numeric", "assign_expr", "return_expr", "expr", "call_args", "bitop",
  "table_index_expr", "scoped_ident", "dotted_ident", "any_ident", "ident", YY_NULLPTR
  };
#endif


#if YYDEBUG
  const short
  BisonParser::yyrline_[] =
  {
       0,   132,   132,   138,   140,   152,   153,   154,   155,   156,
     157,   161,   163,   168,   170,   175,   178,   181,   184,   189,
     192,   193,   194,   196,   197,   201,   207,   210,   215,   216,
     217,   218,   221,   227,   229,   234,   240,   242,   247,   251,
     255,   262,   269,   271,   276,   280,   284,   291,   293,   298,
     299,   300,   301,   305,   306,   310,   314,   318,   325,   332,
     332,   333,   338,   344,   345,   359,   360,   363,   366,   372,
     376,   380,   387,   391,   398,   404,   406,   411,   414,   420,
     423,   426,   429,   432,   435,   441,   455,   461,   463,   465,
     467,   469,   471,   475,   479,   483,   486,   489,   492,   494,
     496,   499,   501,   503,   506,   509,   512,   515,   518,   521,
     524,   527,   530,   533,   536,   539,   542,   545,   548,   553,
     556,   563,   564,   566,   571,   574,   580,   586,   588,   593,
     595,   600,   602,   604,   606,   611
  };

  void
  BisonParser::yy_stack_print_ () const
  {
    *yycdebug_ << "Stack now";
    for (stack_type::const_iterator
           i = yystack_.begin (),
           i_end = yystack_.end ();
         i != i_end; ++i)
      *yycdebug_ << ' ' << int (i->state);
    *yycdebug_ << '\n';
  }

  void
  BisonParser::yy_reduce_print_ (int yyrule) const
  {
    int yylno = yyrline_[yyrule];
    int yynrhs = yyr2_[yyrule];
    // Print the symbols being reduced, and their result.
    *yycdebug_ << "Reducing stack by rule " << yyrule - 1
               << " (line " << yylno << "):\n";
    // The symbols being reduced.
    for (int yyi = 0; yyi < yynrhs; yyi++)
      YY_SYMBOL_PRINT ("   $" << yyi + 1 << " =",
                       yystack_[(yynrhs) - (yyi + 1)]);
  }
#endif // YYDEBUG

  BisonParser::symbol_kind_type
  BisonParser::yytranslate_ (int t)
  {
    // YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to
    // TOKEN-NUM as returned by yylex.
    static
    const signed char
    translate_table[] =
    {
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63
    };
    // Last valid token kind.
    const int code_max = 318;

    if (t <= 0)
      return symbol_kind::S_YYEOF;
    else if (t <= code_max)
      return YY_CAST (symbol_kind_type, translate_table[t]);
    else
      return symbol_kind::S_YYUNDEF;
  }

#line 19 "parser.yy"
} } // ebpf::cc
#line 2151 "/builddir/build/BUILD/bcc/aarch64-redhat-linux-gnu/src/cc/frontends/b/parser.yy.cc"

#line 616 "parser.yy"


void ebpf::cc::BisonParser::error(const ebpf::cc::BisonParser::location_type &loc,
                            const string& msg) {
    std::cerr << "Error: " << loc << " " << msg << std::endl;
}

#include "lexer.h"
static int yylex(ebpf::cc::BisonParser::semantic_type *yylval,
                 ebpf::cc::BisonParser::location_type *yylloc,
                 ebpf::cc::Lexer &lexer) {
    return lexer.yylex(yylval, yylloc);
}

